/*
 *   
 */

#include "head.h"

char *_normal,*_special,*_head,
     *_highlight,*_sel,*_control,*_error,*_std,
     *_dialog, *_button, *_virgin, *_line,
     *_cline, *_sline, *_number, *_cursor,
     *_is, *_rs, *_xtitle;

char *_rusmap,*_rus,*_lat;
int _isrus;

char *_bell;
char *_curpos,*_clreol,*_clrscr,
     *_iline,*_dline,*_scrup,*_scra;
char *_scrdn="\n";
char _graph0[] = "++++||--"; //"+-+-||--";
char *_graph;
char *_graph_on="",*_graph_off="";
char *_fill="";

int SWIDTH;             //  -1
int SHEIGHT;            //  -1

#if __MSDOS__
unsigned char MINRUS='';
inline int isrus(unsigned ch) {
  return (128<=ch)&&(ch<=175)||(224<=ch)&&(ch<=239);
 }
#else
unsigned char MINRUS=0300;
inline int isrus(unsigned ch) {
  return (0300<=ch)&&(ch<=0377);
}
#endif

//  ?
inline int islat(unsigned char ch) {
  return (040<=ch)&&(ch<=127);
}

//      
void pch (char c) {
  unsigned ch=(unsigned char)c;

  if ((ch>=MINRUS)&&(ch-MINRUS<64)&&(_rusmap))
    ch=(unsigned char)RusMap[ch-MINRUS];
  if (isrus(ch)&&(_rus)) prtc(_rus);
  else if (islat(ch)&&(_lat)) prtc(_lat);
  putc(ch,stdout);
} //pch

//  
int prt (char *str) {
  if (str==NULL) return 0;
  while (*str) pch(*str++);
  return 1;
} //prt

//    len
int prtn (char *str, int len) {
  char *p;
  int i;

  if (str==NULL) return 0;
  for (p=str,i=0; *p && (i<len); p++, i++)
    pch(*p);
  if (i>=len) return 1;
  for (; i<len; i++)
    pch(' ');
  return 0;
} //prtn

//    ( )
int prtc (char *format, int y, int x) {
  char *p;
  int incr=0;
  int arg[2];
  int i,num,mult;

  if (format==NULL) return 0;
  arg[0]=y; arg[1]=x;
  p=format; num=0; mult=0;
  while (isdigit(*p)) {
    num=num*10+(*p-'0');
    p++;
  }
  if (*p=='*') {
    mult=1;
    p++;
  }
  for (i=0; *p && (i<=2); p++)
    if (*p!='%') pch(*p);
    else {
      switch (*++p) {
        case 'd':
          fprintf(stdout,"%d",arg[i++]+incr);
          break;
        case '2':
          fprintf(stdout,"%02d",arg[i++]+incr);
          break;
        case '3':
          fprintf(stdout,"%03d",arg[i++]+incr);
          break;
        case '.':
          fprintf(stdout,"%c",arg[i++]+incr);
          break;
        case 'r':
          arg[0]=x; arg[1]=y;
          break;
        case 'i':
          incr=1;
          break;
        case '+':
          fprintf(stdout,"%c",*++p+arg[i++]+incr);
          break;
        case '<':
          ++p;
          if (arg[i]<*p++)
            fprintf(stdout,"%c",*p+arg[i++]+incr);
          break;
        case 'n':
          x ^= 0140;
          y ^= 0140;
          break;
        case '%':
          pch('%');
          break;
        default:
          pch(*p);
      } //switch
    } //if, for
   /*
   if (speed>=minspeed) {   // 
     if (mult) num*=y;
     num=(long)speed/8*num/1000;
     for (i=0; i<num; i++)
       pch(*_fill);
   }
   */
   return 1;
} //prtc

int initscr() { //  
  return prtc(_is,0,0);
}

int resetscr() {  //  
  return prtc(_rs,0,0);
}

void xtitle (char *str) {
  if (str==NULL) str="xterm";
  if (_xtitle) printf(_xtitle,str);
}

//      
int clreol() {
#ifdef __WIN32__
  HANDLE console;
  DWORD n;
  CONSOLE_SCREEN_BUFFER_INFO info;

  console=GetStdHandle(STD_OUTPUT_HANDLE);
  GetConsoleScreenBufferInfo(console,&info);

  FillConsoleOutputCharacter(
    console,  // handle to screen buffer
    ' ', // character to write
    (info.dwSize.X-info.dwCursorPosition.X),  // number of character cells to write to
    info.dwCursorPosition, // x- and y-coordinates of first cell
    &n  // pointer to number of cells written to
   );
  FillConsoleOutputAttribute(
    console,  // handle to screen buffer
    info.wAttributes,  // color attribute to write
    (info.dwSize.X-info.dwCursorPosition.X),  // number of character cells to write to
    info.dwCursorPosition, // x- and y-coordinates of first cell
    &n  // pointer to number of cells written to
   );
  return 1;
#else
  return prtc(_clreol,0,0);
#endif
} //clreol

//  
int clrscr() {
#ifdef __WIN32__
  int i;
  for (i=0; i<=SHEIGHT; i++) {
    curxy(0,i);
    clreol();
  }
#else
  return prtc(_clrscr,0,0);
#endif
} //clrscr

//  
int iline() {
#ifdef __WIN32__
  HANDLE console;
  CONSOLE_SCREEN_BUFFER_INFO info;
  SMALL_RECT ScrollR,ClipR;
  COORD coord;
  CHAR_INFO c;
  console=GetStdHandle(STD_OUTPUT_HANDLE);
  GetConsoleScreenBufferInfo(console,&info);
  ScrollR.Left=0; ScrollR.Right=info.dwSize.X;
  ScrollR.Top=info.dwCursorPosition.Y;
  ScrollR.Bottom=info.dwSize.Y-1;
  ClipR=ScrollR;
  ClipR.Bottom--;
  coord.X=0; coord.Y=ScrollR.Top+1;
  c.Char.AsciiChar=' ';
  c.Attributes=info.wAttributes;
  ScrollConsoleScreenBuffer(
    console,  // handle of a console screen buffer
    &ScrollR,  // address of screen buffer rect. to move
    &ClipR,  // address of affected screen buffer rect.
    coord,  // new location of screen buffer rect.
    &c   // address of fill character and color
   );
#else
  return prtc(_iline,0,0);
#endif
} //iline

//  
int dline() {
#ifdef __WIN32__
  HANDLE console;
  CONSOLE_SCREEN_BUFFER_INFO info;
  SMALL_RECT ScrollR,ClipR;
  COORD coord;
  CHAR_INFO c;
  console=GetStdHandle(STD_OUTPUT_HANDLE);
  GetConsoleScreenBufferInfo(console,&info);
  ScrollR.Left=0; ScrollR.Right=info.dwSize.X;
  ScrollR.Top=info.dwCursorPosition.Y+1;
  ScrollR.Bottom=info.dwSize.Y-2;
  ClipR=ScrollR;
  ClipR.Top--;
  coord.X=0; coord.Y=ScrollR.Top-1;
  c.Char.AsciiChar=' ';
  c.Attributes=info.wAttributes;
  ScrollConsoleScreenBuffer(
    console,  // handle of a console screen buffer
    &ScrollR,  // address of screen buffer rect. to move
    &ClipR,  // address of affected screen buffer rect.
    coord,  // new location of screen buffer rect.
    &c   // address of fill character and color
   );
#else
  return prtc(_dline,0,0);
#endif
} //dline

//  
int Color (int cnum) {
  static int ColNum=0;
  int res=0;

  if (ColNum==cnum) return 1;
  ColNum=cnum;
#ifdef __WIN32__
  switch (cnum) {
    case 1:
      //res=prtc(_head);
      SetConsoleTextAttribute(GetStdHandle(STD_OUTPUT_HANDLE),
        BACKGROUND_GREEN|BACKGROUND_BLUE);
      break;
    case 2:
      //res=prtc(_special);
      SetConsoleTextAttribute(GetStdHandle(STD_OUTPUT_HANDLE),
        FOREGROUND_RED|FOREGROUND_GREEN|FOREGROUND_BLUE|BACKGROUND_BLUE);
      break;
    case 3:
      //res=prtc(_control);
      SetConsoleTextAttribute(GetStdHandle(STD_OUTPUT_HANDLE),
        FOREGROUND_RED|FOREGROUND_GREEN|FOREGROUND_BLUE|BACKGROUND_BLUE);
      break;
    case 4:
      //res=prtc(_highlight);
      SetConsoleTextAttribute(GetStdHandle(STD_OUTPUT_HANDLE),
        BACKGROUND_RED|BACKGROUND_GREEN|BACKGROUND_BLUE);
      break;
    case 5:
      //res=prtc(_sel);
      SetConsoleTextAttribute(GetStdHandle(STD_OUTPUT_HANDLE),
        BACKGROUND_RED|BACKGROUND_GREEN|BACKGROUND_BLUE);
      break;
    case 6:
      //res=prtc(_error);
      SetConsoleTextAttribute(GetStdHandle(STD_OUTPUT_HANDLE),
        FOREGROUND_RED|FOREGROUND_GREEN|FOREGROUND_BLUE|BACKGROUND_RED);
      break;
    case 7:
      //res=prtc(_normal);
      SetConsoleTextAttribute(GetStdHandle(STD_OUTPUT_HANDLE),
        FOREGROUND_INTENSITY|FOREGROUND_RED|FOREGROUND_GREEN|FOREGROUND_BLUE|BACKGROUND_BLUE);
      break;
    case 8:
      //res=prtc(_dialog);
      SetConsoleTextAttribute(GetStdHandle(STD_OUTPUT_HANDLE),
        BACKGROUND_RED|BACKGROUND_GREEN|BACKGROUND_BLUE);
      break;
    case 9:
      //res=prtc(_button);
      SetConsoleTextAttribute(GetStdHandle(STD_OUTPUT_HANDLE),
        BACKGROUND_GREEN|BACKGROUND_BLUE);
      break;
    case 10:
      //res=prtc(_virgin);
      SetConsoleTextAttribute(GetStdHandle(STD_OUTPUT_HANDLE),
        FOREGROUND_RED|FOREGROUND_GREEN|FOREGROUND_BLUE|
        BACKGROUND_GREEN|BACKGROUND_BLUE);
      break;
    case 11:
      //res=prtc(_line);
      SetConsoleTextAttribute(GetStdHandle(STD_OUTPUT_HANDLE),
        FOREGROUND_RED|FOREGROUND_GREEN|FOREGROUND_BLUE);
      break;
    case 12:
      //res=prtc(_cline);
      SetConsoleTextAttribute(GetStdHandle(STD_OUTPUT_HANDLE),
        FOREGROUND_GREEN|FOREGROUND_BLUE|
        BACKGROUND_RED|BACKGROUND_GREEN|BACKGROUND_BLUE);
      break;
    case 13:
      //res=prtc(_sline);
      SetConsoleTextAttribute(GetStdHandle(STD_OUTPUT_HANDLE),
        FOREGROUND_GREEN|FOREGROUND_BLUE|
        BACKGROUND_RED|BACKGROUND_GREEN|BACKGROUND_BLUE);
      break;
    case 14:
      //res=prtc(_number);
      SetConsoleTextAttribute(GetStdHandle(STD_OUTPUT_HANDLE),
        FOREGROUND_RED|FOREGROUND_GREEN|FOREGROUND_BLUE);
      break;
    case 15:
      //res=prtc(_cursor);
      SetConsoleTextAttribute(GetStdHandle(STD_OUTPUT_HANDLE),
        FOREGROUND_RED|FOREGROUND_GREEN|FOREGROUND_BLUE|
        BACKGROUND_GREEN|BACKGROUND_BLUE);
      break;
    default:
      ColNum=0;
      SetConsoleTextAttribute(GetStdHandle(STD_OUTPUT_HANDLE),
        FOREGROUND_RED|FOREGROUND_GREEN|FOREGROUND_BLUE);
      break;
  } //switch
  res=1;
#else
  switch (cnum) {
    case 1:
      res=prtc(_head); break;
    case 2:
      res=prtc(_special); break;
    case 3:
      res=prtc(_control); break;
    case 4:
      res=prtc(_highlight); break;
    case 5:
      res=prtc(_sel); break;
    case 6:
      res=prtc(_error); break;
    case 7:
      res=prtc(_normal); break;
    case 8:
      res=prtc(_dialog); break;
    case 9:
      res=prtc(_button); break;
    case 10:
      res=prtc(_virgin); break;
    case 11:
      res=prtc(_line); break;
    case 12:
      res=prtc(_cline); break;
    case 13:
      res=prtc(_sline); break;
    case 14:
      res=prtc(_number); break;
    case 15:
      res=prtc(_cursor); break;
    default:
      ColNum=0;
      res=prtc(_std); break;
  } //switch
#endif
  return res;
} //Color
